SystemOrganization addCategory: #'Seaside-Tests-RenderLoop'!

!GRPackage class methodsFor: '*seaside-tests-renderloop' stamp: 'lr 2/17/2010 15:14'!
seasideTestsRenderLoop
	^ self new
		name: 'Seaside-Tests-RenderLoop';
		description: 'Unit tests for the package Seaside-RenderLoop.';
		addDependency: 'Seaside-RenderLoop';
		addDependency: 'Seaside-Tests-Session';
		url: #seasideUrl;
		yourself! !

WAErrorHandler subclass: #WASignalingErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-RenderLoop'!

!WASignalingErrorHandler methodsFor: 'actions' stamp: 'pmm 8/29/2011 12:29'!
handleException: anException
	WARenderNotification signal! !

TestCase subclass: #WARenderLoopContinuationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-RenderLoop'!

!WARenderLoopContinuationTest methodsFor: 'tests' stamp: 'pmm 8/29/2011 12:34'!
testExceptionHandlerNesting
	| continuation handler |
	continuation := WARenderLoopContinuation new.
	handler := WASignalingErrorHandler new.
	self
		shouldnt:  [
			handler handleExceptionsDuring: [
				continuation withNotificationHandlerDo: [
					WAError signal: 'Testing 1, 2, 3' ] ] ]
		raise: WARenderNotification! !
